/*
 * opt3007_hostControl.c
 *
 *  Created on: Sep 18, 2020
 *      Author: Karthik Rajagopal
 */

#include "opt3007_hostControl.h"

uint16_t ti_opt3007_I2C_read(uint8_t registerAddress){
	//I2C read operation and return uint16_t value as per datasheet
	// Data should be in first byte received from I2C denotes 15:8 and 2nd byte from I2C denotes 7:0
	uint16_t returnValue=0;
#ifdef RASPBERRY_PI
    char *fileName=(char*)"/dev/i2c-1";
    int fileI2C;
    uint8_t buffer[2];
    if((fileI2C=open(fileName,O_RDWR))<0)
        printf("ERROR:Not able to perform I2C operation\n");
    if(ioctl(fileI2C,I2C_SLAVE,TI_OPT3007_BUSADDRESS)<0)
        printf("ERROR:Unable to set I2C address\n");
    if(write(fileI2C,&registerAddress,1)!=1)
        printf("ERROR:Write operation to set read register address failed\n");
    if(read(fileI2C,buffer,2)!=2)
        printf("ERROR:Read operation failed\n");
    returnValue=buffer[1] | (((uint16_t)buffer[0])<<8);
    printf("INFO:I2C Read operation Value from register 0x%02x is 0x%02x\n",registerAddress,returnValue);
#endif
	return returnValue;

}
void ti_opt3007_I2C_write(uint8_t registerAddress,uint16_t value){
	//I2C write operation to the denoted register
	// Data should be in first byte sent on I2C denotes 15:8 and 2nd byte sent to I2C denotes 7:0
#ifdef RASPBERRY_PI
    char *fileName=(char*)"/dev/i2c-1";
    int fileI2C;
    uint8_t buffer[3];
    buffer[0]=registerAddress;
    buffer[1]=value>>8;
    buffer[2]=value&0x00FF;
    if((fileI2C=open(fileName,O_RDWR))<0)
        printf("ERROR:Not able to perform I2C operation\n");
    if(ioctl(fileI2C,I2C_SLAVE,TI_OPT3007_BUSADDRESS)<0)
        printf("ERROR:Unable to set I2C address\n");
    if(write(fileI2C,buffer,3)!=3)
        printf("ERROR:Write operation failed\n");
    printf("INFO:I2C Write operation Value from register 0x%02x is 0x%02x\n",registerAddress,value);
#endif
}
